KDE 4.7 PyKDE API Reference

- KDE's Python API

# Extender Class Reference

`from PyKDE4.plasma import *`

Inherits: QGraphicsWidget → QObject
Namespace: Plasma

## Detailed Description

Extender plasma/extender.h <Plasma/Extender>

Extends applets to allow detachable parts

An Extender is a widget that visually extends the normal contents of an applet with additional dynamic widgets called ExtenderItems. These ExtenderItems can be detached by the user and dropped either on another Extender or on the canvas directly.

This widget allows using ExtenderItems in your applet. Extender takes care of the presentation of a collection of ExtenderItems and keeps track of ExtenderItems that originate in it.

The default Extender implementation displays extender items in a vertical layout with spacers that appear when dropping an ExtenderItem over it.

If you wish to have a different presentation of extender items, you can choose to subclass Extender and reimplement the extenderItem* events and, optionally, the saveState function.

To use an Extender in you applet, you'll have to instantiate one. A call to extender() in your applet will create an extender on your applet if you haven't got one already. Every applet can contain only one extender. Think of it as a decorator that adds some functionality to applets that require it. Never instantiate an Extender before init() in your applet. This won't work correctly since a scene is required when an Extender is instantiated.

As soon as an Extender is instantiated, ExtenderItems contained previously in this Extender are restored using the initExtenderItem function from the applet the items originally came from. For more information on how this works and how to use ExtenderItems in general, see the ExtenderItem API documentation.

## Enumerations
Appearance | { NoBorders, BottomUpStacked, TopDownStacked }
## Signals
| geometryChanged ()
| itemAttached (Plasma.ExtenderItem a0)
| itemDetached (Plasma.ExtenderItem a0)
## Methods
| __init__ (self, Plasma.Applet applet)
Plasma.Extender.Appearance | appearance (self)
Plasma.Applet | applet (self)
[Plasma.ExtenderItem] | attachedItems (self)
[Plasma.ExtenderItem] | detachedItems (self)
| dragEnterEvent (self, QGraphicsSceneDragDropEvent event)
| dragLeaveEvent (self, QGraphicsSceneDragDropEvent event)
| dragMoveEvent (self, QGraphicsSceneDragDropEvent event)
| dropEvent (self, QGraphicsSceneDragDropEvent event)
QString | emptyExtenderMessage (self)
Plasma.FrameSvg.EnabledBorders | enabledBordersForItem (self, Plasma.ExtenderItem item)
Plasma.ExtenderGroup | group (self, QString name)
[Plasma.ExtenderGroup] | groups (self)
bool | hasItem (self, QString name)
bool | isEmpty (self)
Plasma.ExtenderItem | item (self, QString name)
| itemAddedEvent (self, Plasma.ExtenderItem item, QPointF pos=QPointF(-1,-1))
QVariant | itemChange (self, QGraphicsItem::GraphicsItemChange change, QVariant value)
| itemHoverEnterEvent (self, Plasma.ExtenderItem item)
| itemHoverLeaveEvent (self, Plasma.ExtenderItem item)
| itemHoverMoveEvent (self, Plasma.ExtenderItem item, QPointF pos)
| itemRemovedEvent (self, Plasma.ExtenderItem item)
[Plasma.ExtenderItem] | items (self)
| mousePressEvent (self, QGraphicsSceneMouseEvent event)
| resizeEvent (self, QGraphicsSceneResizeEvent event)
| saveState (self)
| setAppearance (self, Plasma.Extender.Appearance appearance)
| setEmptyExtenderMessage (self, QString message)

## Signal Documentation

geometryChanged | ( |  | ) |

Fires when an extender's preferred size changes.

Signal syntax:
  `QObject.connect(source, SIGNAL("geometryChanged()"), target_slot)`

itemAttached | ( | Plasma.ExtenderItem | a0
| ) |  |  |

Fires when an extender item is added to this extender.

Signal syntax:
  `QObject.connect(source, SIGNAL("itemAttached(Plasma::ExtenderItem*)"), target_slot)`

itemDetached | ( | Plasma.ExtenderItem | a0
| ) |  |  |

Fires when an extender item is removed from this extender.

Signal syntax:
  `QObject.connect(source, SIGNAL("itemDetached(Plasma::ExtenderItem*)"), target_slot)`

## Method Documentation

__init__ | ( | self, |
|  | Plasma.Applet | applet
| ) |  |  |

Creates an extender. Note that extender expects applet to have a config(), and needs a scene because of that. So you should only instantiate an extender in init() or later, not in an applet's constructor. The constructor also takes care of restoring ExtenderItems that were contained in this extender before, so ExtenderItems are persistent between sessions. Note that a call to extender() in an applet will instantiate an Extender for you if one isn't already associated with your applet.

Parameters:

  | applet | The applet this extender is part of. Null is not allowed here.

Plasma.Extender.Appearance appearance | ( |  | self ) |

Returns:
  the current way of rendering extender items that is used.

Plasma.Applet applet | ( |  | self ) |

Returns:
  the Applet this Extender is associated with

Since:
  4.4

[Plasma.ExtenderItem] attachedItems | ( |  | self ) |

Returns:
  a list of all attached extender items.

[Plasma.ExtenderItem] detachedItems | ( |  | self ) |

Returns:
  a list of all detached extender items.

dragEnterEvent | ( | self, |
|  | QGraphicsSceneDragDropEvent | event
| ) |  |  |

Reimplemented from QGraphicsWidget

dragLeaveEvent | ( | self, |
|  | QGraphicsSceneDragDropEvent | event
| ) |  |  |

Reimplemented from QGraphicsWidget

dragMoveEvent | ( | self, |
|  | QGraphicsSceneDragDropEvent | event
| ) |  |  |

Reimplemented from QGraphicsWidget

dropEvent | ( | self, |
|  | QGraphicsSceneDragDropEvent | event
| ) |  |  |

Reimplemented from QGraphicsWidget

QString emptyExtenderMessage | ( |  | self ) |

Returns:
  The text to be shown whenever the applet's layout is empty.

Plasma.FrameSvg.EnabledBorders enabledBordersForItem | ( | self, |
|  | Plasma.ExtenderItem | item
| ) |  |  |

This function get's called on every item to determine which background border's to render.

Parameters:

  | item | the item for which its position or extender has changed.

Returns:
  the borders that have to be enabled on its background.

Plasma.ExtenderGroup group | ( | self, |
|  | QString | name
| ) |  |  |

Extra convenience function for obtaining groups specified by name. This will avoid needed to call item and casting to ExtenderGroup, which is otherwise quite common.

Returns:
  the requested group

Since:
  4.3

[Plasma.ExtenderGroup] groups | ( |  | self ) |

Returns:
  a list of groups that are contained in this extender.

Since:
  4.3

bool hasItem | ( | self, |
|  | QString | name
| ) |  |  |

This function can be used for easily determining if a certain item is already displayed in an extender item somewhere, so your applet doesn't duplicate this item. This is needed because ExtenderItems are persistent, so you can't blindly add new extender items in all cases.

Returns:
  whether or not this item already exists.

Since:
  4.3

bool isEmpty | ( |  | self ) |

Returns:
  true if the Extender is visually empty (though it may have items such as empty groups or detached items associatd with it)

Plasma.ExtenderItem item | ( | self, |
|  | QString | name
| ) |  |  |

This function can be used for obtaining the extender item specified by name. For checking whether or not an item already exists, you should use hasItem instead: while plasma is starting up, not all detached items might have been instantiated yet. hasItem returns true even if the requested item isn't instantiated yet.

Returns:
  the requested item

itemAddedEvent | ( | self, |
|  | Plasma.ExtenderItem | item,
|  | QPointF | pos=QPointF(-1,-1)
| ) |  |  |

Get's called after an item has been added to this extender. The bookkeeping has already been done when this function get's called. The only thing left to do is put it somewhere appropriate. The default implementation adds the extenderItem to the appropriate place in a QGraphicsLinearLayout.

Parameters:

  | item | The item that has just been added.
  | pos | The location the item has been dropped in local coordinates.

QVariant itemChange | ( | self, |
|  | QGraphicsItem::GraphicsItemChange | change,
|  | QVariant | value
| ) |  |  |

Reimplemented from QGraphicsWidget

itemHoverEnterEvent | ( | self, |
|  | Plasma.ExtenderItem | item
| ) |  |  |

Get's called when an ExtenderItem that get's dragged enters this extender. Default implementation does nothing.

itemHoverLeaveEvent | ( | self, |
|  | Plasma.ExtenderItem | item
| ) |  |  |

Get's called when an ExtenderItem that was previously hovering over this extender moves away from this extender. The default implementation removes any spacer from the layout.

itemHoverMoveEvent | ( | self, |
|  | Plasma.ExtenderItem | item,
|  | QPointF | pos
| ) |  |  |

Gets called when an ExtenderItem is hovering over this extender. Implement this function to give some visual feedback about what will happen when the mouse button is released at that position. The default implementation shows a spacer at the appropriate location in the layout.

Parameters:

  | item | The item that's hovering over this extender. Most useful for obtaining the size of the spacer.
  | pos | The location the item is hovering.

itemRemovedEvent | ( | self, |
|  | Plasma.ExtenderItem | item
| ) |  |  |

Get's called after an item has been removed from this extender. All bookkeeping has already been done when this function get's called.

Parameters:

  | item | The item that has just been removed.

[Plasma.ExtenderItem] items | ( |  | self ) |

Returns:
  a list of all extender items (attached AND detached) where the source applet is this applet.

mousePressEvent | ( | self, |
|  | QGraphicsSceneMouseEvent | event
| ) |  |  |

Reimplemented from QGraphicsWidget

resizeEvent | ( | self, |
|  | QGraphicsSceneResizeEvent | event
| ) |  |  |

Reimplemented from QGraphicsWidget

saveState | ( |  | self ) |

This function get's called for every extender when plasma exits. Implement this function to store the current state of this extender (position in a layout for example), so this can be restored when applet starts again. The default implementation stores the y coordinate of every extender item in the config field extenderItemPos.

setAppearance | ( | self, |
|  | Plasma.Extender.Appearance | appearance
| ) |  |  |

Use this function to instruct the extender on how to render its items. Usually you will want to call this function in your applet's constraintsEvent, allthough this is already done for you when using PopupApplet as base class for your applet. Defaults to NoBorders.

Parameters:

  | appearance | the way this extender should look.

setEmptyExtenderMessage | ( | self, |
|  | QString | message
| ) |  |  |

Parameters:

  | message | The text to be shown whenever the applet's extender is empty.

## Enumeration Documentation

Appearance

Description on how to render the extender's items.

Enumerator:

  NoBorders = 0 |
  BottomUpStacked = 1 |
  TopDownStacked = 2 |